package io.github.zskamljic.restahead.demo;

import io.github.zskamljic.restahead.client.Client;
import io.github.zskamljic.restahead.client.requests.Request;
import io.github.zskamljic.restahead.client.requests.Verb;
import io.github.zskamljic.restahead.conversion.Converter;
import io.github.zskamljic.restahead.conversion.GenericReference;
import io.github.zskamljic.restahead.exceptions.RequestFailedException;
import java.io.IOException;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.util.Map;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.CompletionException;
import java.util.concurrent.Future;
import javax.annotation.processing.Generated;

@Generated("Generated by RestAhead")
public final class FutureGenericResponse$Impl implements FutureGenericResponse {
    private final String baseUrl;

    private final Client client;

    private final Converter converter;

    public FutureGenericResponse$Impl(String baseUrl, Client client, Converter converter) {
        this.baseUrl = baseUrl;
        this.client = client;
        this.converter = converter;
    }

    @Override
    public final Future<Map<String, Object>> delete() {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.DELETE)
            .setBaseUrl(baseUrl)
            .setPath("/delete");
        var response = client.execute(httpRequestBuilder.build());
        CompletableFuture<Map<String, Object>> convertedResponse = response.thenApply(r -> {
            if (r.status() < 200 || r.status() >= 300) {
                throw new RequestFailedException(r.status(), r.body());
            }
            try {
                var conversionTypeHolder = new GenericReference<Map<String, Object>>(){};
                Map<String, Object> deserializedResponse = converter.deserialize(r, conversionTypeHolder.getType());
                return deserializedResponse;
            } catch (IOException exception) {
                throw new CompletionException(exception);
            }
        } );
        return convertedResponse;
    }
}