package io.github.zskamljic.restahead.demo;

import io.github.zskamljic.restahead.adapter.DefaultAdapters;
import io.github.zskamljic.restahead.client.Client;
import io.github.zskamljic.restahead.client.requests.Request;
import io.github.zskamljic.restahead.client.requests.Verb;
import io.github.zskamljic.restahead.client.responses.BodyResponse;
import io.github.zskamljic.restahead.conversion.Converter;
import io.github.zskamljic.restahead.conversion.GenericReference;
import io.github.zskamljic.restahead.exceptions.RestException;
import java.io.IOException;
import java.lang.InterruptedException;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.CompletionException;
import java.util.concurrent.ExecutionException;
import javax.annotation.processing.Generated;

@Generated("Generated by RestAhead")
public final class ResponseWithBody$Impl implements ResponseWithBody {
    private final String baseUrl;

    private final Client client;

    private final Converter converter;

    private final DefaultAdapters defaultAdapters;

    public ResponseWithBody$Impl(String baseUrl, Client client, Converter converter,
                                 DefaultAdapters defaultAdapters) {
        this.baseUrl = baseUrl;
        this.client = client;
        this.converter = converter;
        this.defaultAdapters = defaultAdapters;
    }

    @Override
    public final BodyResponse<ResponseWithBody.SomeObject> delete() {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.DELETE)
            .setBaseUrl(baseUrl)
            .setPath("/delete");
        var response = client.execute(httpRequestBuilder.build());
        CompletableFuture<BodyResponse<ResponseWithBody.SomeObject>> convertedResponse = response.thenApply(r -> {
            if (r.status() < 200 || r.status() >= 300) {
                return new BodyResponse<ResponseWithBody.SomeObject>(r.status(), r.headers(), Optional.empty(), Optional.of(r.body()));
            }
            try {
                ResponseWithBody.SomeObject deserializedResponse = converter.deserialize(r, ResponseWithBody.SomeObject.class);
                return new BodyResponse<ResponseWithBody.SomeObject>(r.status(), r.headers(), Optional.of(deserializedResponse), Optional.empty());
            } catch (IOException exception) {
                throw new CompletionException(exception);
            }
        } );
        try {
            return defaultAdapters.syncAdapter(convertedResponse);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }

    @Override
    public final BodyResponse<Map<String, Object>> deleteMap() {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.DELETE)
            .setBaseUrl(baseUrl)
            .setPath("/delete");
        var response = client.execute(httpRequestBuilder.build());
        CompletableFuture<BodyResponse<Map<String, Object>>> convertedResponse = response.thenApply(r -> {
            if (r.status() < 200 || r.status() >= 300) {
                return new BodyResponse<Map<String, Object>>(r.status(), r.headers(), Optional.empty(), Optional.of(r.body()));
            }
            try {
                var conversionTypeHolder = new GenericReference<Map<String, Object>>(){};
                Map<String, Object> deserializedResponse = converter.deserialize(r, conversionTypeHolder.getType());
                return new BodyResponse<Map<String, Object>>(r.status(), r.headers(), Optional.of(deserializedResponse), Optional.empty());
            } catch (IOException exception) {
                throw new CompletionException(exception);
            }
        } );
        try {
            return defaultAdapters.syncAdapter(convertedResponse);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }
}